<template>
  <b-modal
    id="coscineAuthorizationModal"
    v-model="isOpen"
    :title="$t('coscine.authorizationModalTitle')"
    :cancel-title="$t('Cancel')"
    :ok-title="$t('Save')"
    @ok="save"
    @cancel="close"
    @close="close"
    @hidden="hidden"
  >
    <label
      id="coscineToken"
      class="form-label d-inline-flex gap-1 align-items-center"
      >{{ $t("coscine.tokenLabel") }}</label
    >
    <b-form-input
      id="coscineToken"
      v-model="token"
      class="mb-3"
      :placeholder="$t('coscine.tokenLabel')"
      trim
    />

    <i18n-t scope="global" keypath="coscine.tokenNotice" tag="label">
      <a :href="$t('coscine.tokenUrl').toString()" target="_blank">{{
        $t("coscine.tokenHere")
      }}</a>
    </i18n-t>
  </b-modal>
</template>

<script lang="ts">
import { defineComponent } from "vue";

export default defineComponent({
  name: "CoscineAuthorizationModal",
  props: {
    open: {
      required: true,
      default: () => false,
      type: Boolean,
    },
  },
  data() {
    return {
      isOpen: false,
      token: "",
    };
  },
  watch: {
    open() {
      this.isOpen = this.open;
    },
  },
  methods: {
    close() {
      this.isOpen = false;
    },
    hidden() {
      this.$emit("close");
    },
    save() {
      window.coscine.authorization.bearer = this.token;
      this.$emit("save");
    },
  },
});
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>
